diff --git a/contrib/dlmalloc/Makefile b/contrib/dlmalloc/Makefile
new file mode 100644
index 000000000000..738a65cb2768
--- /dev/null
+++ b/contrib/dlmalloc/Makefile
@@ -0,0 +1,61 @@
+SDKBIN?=/home/bed22/git/llvm-project-cheri/Build/bin
+SDKROOT?=/home/bed22/bsdtools/cheribsd-root/cheribsd128
+CC=${SDKBIN}/clang -target cheri-unknown-freebsd --sysroot=${SDKROOT}
+LD=${CC} -fuse-ld=lld -B ${SDKBIN}
+DEBUG?=1
+
+CFLAGS=-Wall -Werror
+CFLAGS+=-mabi=purecap -msoft-float
+CFLAGS+=-std=c11
+CFLAGS+=-Wno-error=unused-function
+
+CFLAGS+=-DCAPREVOKE -DCHERI_SET_BOUNDS
+LDFLAGS+=-lcheri_caprevoke
+
+CFLAGS+=-DSAFE_FREEBUF
+
+ifeq ($(DEBUG),1)
+CFLAGS+=-O0
+CFLAGS+=-ggdb
+CFLAGS+=-DDEBUG=1 -DABORT_ON_ASSERT_FAILURE=1 -DVERBOSE=1
+else # DEBUG
+CFLAGS+=-O3
+CFLAGS+=-g0
+CFLAGS+=-fomit-frame-pointer
+CFLAGS+=-fno-stack-protector
+CFLAGS+=-DINSECURE=1
+
+ifneq (,$(findstring clang,$(CC)))
+ifneq (,$(findstring lld,$(LD)))
+# Use link-time optimizations if clang/lld.
+CFLAGS+=-flto
+LDFLAGS+=-O3
+LDFLAGS+=--lto-O3
+endif
+endif
+
+endif # DEBUG
+
+ifeq ($(DEBUG),1)
+libdlmalloc_nonreuse.so: dlmalloc_nonreuse.o
+	$(LD) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^
+else
+libdlmalloc_nonreuse.so: dlmalloc_nonreuse.o
+	$(LD) $(CFLAGS) $(LDFLAGS) -shared $^ -o $@
+	strip $@
+endif
+
+dlmalloc_nonreuse.o: dlmalloc_nonreuse.c dlmalloc_nonreuse.h
+	$(CC) $(CFLAGS) -fPIC -c $< -o $@
+
+dlmalloc_nonreuse-dlprefix.o: dlmalloc_nonreuse.c dlmalloc_nonreuse.h
+	$(CC) $(CFLAGS) -DUSE_DL_PREFIX -c $< -o $@
+
+dlmalloc_test.o: dlmalloc_test.c
+	$(CC) $(CFLAGS) -DUSE_DL_PREFIX -c $< -o $@
+
+dlmalloc_test: dlmalloc_nonreuse-dlprefix.o dlmalloc_test.o
+	$(LD) $(CFLAGS) $(LDFLAGS) -static dlmalloc_nonreuse-dlprefix.o dlmalloc_test.o -o $@
+
+clean:
+	rm -f dlmalloc_test *.o *.so
diff --git a/contrib/dlmalloc/Makefile.cheribuild b/contrib/dlmalloc/Makefile.cheribuild
new file mode 100644
index 000000000000..1335c17bd8db
--- /dev/null
+++ b/contrib/dlmalloc/Makefile.cheribuild
@@ -0,0 +1,24 @@
+# A minimal makefile, designed to be piloted externally rather than set
+# preferences here.
+
+SRCDIR?=.
+CPPFLAGS+=-I$(SRCDIR)
+
+CFLAGS+=-g
+ifeq ($(DEBUG),1)
+# -O2 can't be debugged and -O0 is quite slow so default to -O1
+CFLAGS+=-DDEBUG=1 -DABORT_ON_ASSERT_FAILURE=1 -ggdb -DVERBOSE=1 -DINSECURE=0 -O1
+else
+# XXX NWF?
+CFLAGS+= -DINSECURE=1
+endif
+
+ifeq ($(CAPREVOKE),1)
+CFLAGS+=-DCAPREVOKE
+LDFLAGS+=-lcheri_caprevoke
+endif
+
+all: libdlmalloc_nonreuse.so
+
+libdlmalloc_nonreuse.so: $(SRCDIR)/dlmalloc_nonreuse.c $(SRCDIR)/dlmalloc_nonreuse.h
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -shared -o $@ $<
